HDU 1394 线段树

来源:互联网 发布:c语言 final 编辑:程序博客网 时间:2024/06/08 18:55

Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 21074    Accepted Submission(s): 12641


Problem Description
The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.
 

Input
The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.
 

Output
For each case, output the minimum inversion number on a single line.
 

Sample Input
101 3 6 9 0 8 5 7 4 2
 

Sample Output
16

题意: 给你一个序列,然后输出这个序列的最小逆序数。每次可以将头位置的数挪到尾位置。
最小逆序数定义: (看一下这个大佬的解释吧,让我来粘贴一下)
在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面的数,那么它们就称为一个逆序。一个排列中逆序的总数就称为这个排列的逆序数。逆序数为偶数的排列称为偶排列;逆序数为奇数的排列称为奇排列。如2431中,21,43,41,31是逆序,逆序数是4,为偶排列。
也是就说,对于n个不同的元素,先规定各元素之间有一个标准次序(例如n个 不同的自然数,可规定从小到大为标准次序),于是在这n个元素的任一排列中,当某两个元素的先后次序与标准次序不同时,就说有1个逆序。一个排列中所有逆序总数叫做这个排列的逆序数。

 

题目的意思就好比给出一个序列

如:0 3 4 1 2

设逆序数初始n = 0;

由于0后面没有比它小的,n = 0

3后面有1,2 n = 2

4后面有1,2,n = 2+2 = 4;

所以该序列逆序数为 4

其根据题意移动产生的序列有

3 4 1 2 0   逆序数:8

4 1 2 0 3  逆序数:6

1 2 0 3 4  逆序数:2

2 0 3 4 1  逆序数:4

所以最小逆序数为2

思路: 计算原数列的逆序数吗,仔细研究可以发现这么的一个规律: ans=ans+n-2*a[i]-1;

ans为元数列的逆序数,遍历每一个i 就可以。但是在求原数列的逆序数的时候最好用线段树,提示:建立一个空树,每插入一个数的时候考虑在其前边比他大的个数。不多说了,先按照这个思路写,下边我站上代码。

#include<stdio.h>#include<string.h>#include<iostream>#include<algorithm>#define N 5005using namespace std;struct node{int left,right;int num;}tree[N<<2];int n,ans;int a[N];void push_up(int i){tree[i].num=tree[i<<1].num+tree[i<<1|1].num;}void build(int i,int l,int r){    int mid=(l+r)/2;    tree[i].left=l;    tree[i].right=r;    tree[i].num=0;    if(l==r)    {        return ;    }    build(i*2,l,mid);    build(i*2+1,mid+1,r);}void update(int i,int aim){if(tree[i].left==tree[i].right&&tree[i].left==aim){tree[i].num=1;return ;}int mid=(tree[i].left+tree[i].right)>>1;if(aim<=mid){update(i<<1,aim);}else{update(i<<1|1,aim);}push_up(i);}void query(int i,int left,int right){if(tree[i].left==left&&tree[i].right==right){ans+=tree[i].num;return ;}int mid=(tree[i].left+tree[i].right)>>1;if(right<=mid){query(i<<1,left,right);}else if(left>mid){query(i<<1|1,left,right);}else{query(i<<1,left,mid);query(i<<1|1,mid+1,right);}}int main(){int i,j;while(scanf("%d",&n)!=EOF){memset(a,0,sizeof(a));memset(tree,0,sizeof(tree));for(i=1;i<=n;i++){scanf("%d",&a[i]);}build(1,1,n+1);//for(i=1;i<=20;i++) printf("%d %d %d\n",tree[i].left,tree[i].right,tree[i].num);ans=0;for(i=1;i<=n;i++){query(1,a[i]+1,n);update(1,a[i]+1);}//for(i=1;i<=20;i++) printf("%d %d %d\n",tree[i].left,tree[i].right,tree[i].num);//printf("ans: %d\n",ans);int minx=ans;        for(i=1;i<=n;i++)        {            ans=ans+n-2*a[i]-1;            if(ans<minx)                minx=ans;        }        printf("%d\n",minx);}return 0;}